/*
 * Created on Jul 1, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package gov.grants.apply.soap.util;

import gov.grants.apply.WebServices.ApplicantIntegrationServices_V1_0.ApplicantIntegrationServicesLocator;
import gov.grants.apply.WebServices.ApplicantIntegrationServices_V1_0.ApplicantIntegrationSoapBindingStub;
import gov.grants.apply.struts.Constants;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.util.Properties;

import org.apache.log4j.Logger;

/**
 * @author Brian Husted
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class SoapUtils implements Constants {

	static final Logger log = Logger.getLogger(SoapUtils.class.getName());

	private static Properties props = null;

//	public static final String PROP_FILE = "/resources/" + Constants.SOAP_SERVER_PROPERTY_FILE;
//	public static final String PROP_FILE = Constants.SOAP_SERVER_PROPERTY_FILE;

	public static final String SOAP_HOST = "SOAP_HOST";

	public static final String SOAP_PORT = "SOAP_PORT";

	public static final String ENCODING_TYPE = "ENCODING_TYPE";

	public static final String MIME_ENCODING = "MIME";

	public static final String DIME_ENCODING = "DIME";

	private static String soapServerPropFile = null;

	/**
	 * Get a property value from the soap server properties file.
	 * 
	 * @param key
	 *            An key value
	 * @return The property value or null if no property exists
	 * @throws IOException
	 */
	public static String getProperty(String key) throws IOException {
		log.debug( "find property for key=" + key );
		if (props == null) {
			synchronized (SoapUtils.class) {
				if (props == null) {
					props = loadProperties();
				}
			}

		}
//		log.debug( "props=" + props );
		return props.getProperty(key);

	}

	/**
	 * Load Properties
	 * 
	 * @return The Properties
	 * @throws IOException
	 */
	private static Properties loadProperties() throws IOException {
		Properties props = new Properties();

		InputStream stream = null;
		try {
			if (getSoapServerPropFile() != null) {
				File f = new File( getSoapServerPropFile() );
				if (f.exists()) {
					log.debug( "SOAP_Server.properties file loaded from " + getSoapServerPropFile() );
					stream = new FileInputStream(f);
				} else {
					stream = SoapUtils.class.getResourceAsStream( "/" + soapServerPropFile );
//					log.debug( "SOAP_Server.properties file loaded from /resources on classpath" );
					log.debug( "SOAP_Server.properties file loaded from classes dir on classpath" );
//					String errorMsg = "Cannot load [" + soapServerPropFile + "] from classpath";
//					log.error( errorMsg );
//					throw new IOException( errorMsg );
				}// if-else
				log.debug( "Loading soap properties" );
				props.load(stream);
				log.debug( "soap properties loaded successfully" );
			} else {
				log.error( "Cannot find property file" );
			}// if-else

		} finally {
			try {
				stream.close();
			} catch (Exception ex) {
			}
		}
		return props;
	}

	/**
	 * Get Soap URL
	 * 
	 * @return soap URL
	 * @throws IOException
	 */
	public static String getSoapURL() throws IOException {
		log.debug( "Generating SOAP URL" );
		String soapHost = getProperty( SOAP_HOST );
		String soapPort = getProperty( SOAP_PORT );
		if ( ( !soapHost.endsWith( "/" ) ) && ( !soapPort.startsWith( "/") ) ){
			soapHost += "/";
		}// if
		String soapUrl = soapHost + soapPort;
		log.debug( "soapUrl=" + soapUrl );
		return soapUrl;
	}

	/**
	 * Get Application Soap Stub
	 * 
	 * @return The ApplicantIntegrationSoapBindingStub
	 * @throws Exception
	 */
	public static ApplicantIntegrationSoapBindingStub getApplicantSoapStub()
			throws Exception {
		ApplicantIntegrationServicesLocator service = new ApplicantIntegrationServicesLocator();
		ApplicantIntegrationSoapBindingStub stub = new ApplicantIntegrationSoapBindingStub(
				new URL(getSoapURL()), service);

		return stub;
	}

	/**
	 * Get soap server properties file
	 * 
	 * @return The soapServerPropFile.
	 */
	public static String getSoapServerPropFile() {
		log.debug( "==>soapServerPropfile=" + soapServerPropFile );
		return soapServerPropFile;
	}

	/**
	 * Set soap server property file
	 * 
	 * @param soapServerPropFile
	 *            The soapServerPropFile to set.
	 */
	public static void setSoapServerPropFile(String soapServerPropFile) {
		SoapUtils.soapServerPropFile = soapServerPropFile;
	}
}