/*
 * Created on Feb 17, 2006
 *
 * Unpublished Work, Copyright, 2005, 2006 Northrop Grumman
 */
package gov.grants.common.sql;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

/**
 * @author david.wong2@ngc.com, Grants.gov Team 
 *
 * TODO Add description.
 */
public class ConditionsGroup implements SQLString
{
   private ArrayList _list = null;
   
   ConditionsGroup()
   {

   }

   public void andEquals(SQLString operand1, SQLString operand2)
   {
      WhereCondition cond = WhereCondition.createEquals(operand1, operand2);
      add(Connector.createAndConnector(cond));
   }
   
   public void andEquals(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         andEquals(operand1, operand2);
      }
   }
   
   public void andNotEquals(SQLString operand1, SQLString operand2)
   {
      WhereCondition cond = WhereCondition.createNotEquals(operand1, operand2);
      add(Connector.createAndConnector(cond));
   }
   
   public void andNotEquals(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         andNotEquals(operand1, operand2);
      }
   }
   
   public void andLessThan(SQLString operand1, SQLString operand2)
   {
      WhereCondition cond = WhereCondition.createLessThan(operand1, operand2);
      add(Connector.createAndConnector(cond));
   }
   
   public void andLessThan(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         andLessThan(operand1, operand2);
      }
   }
   
   public void andGreaterThan(SQLString operand1, SQLString operand2)
   {
      WhereCondition cond = WhereCondition.createGreaterThan(operand1, operand2);
      add(Connector.createAndConnector(cond));
   }
   
   public void andGreaterThan(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         andGreaterThan(operand1, operand2);
      }
   }
   
   public void andLessOrEquals(SQLString operand1, SQLString operand2)
   {
      WhereCondition cond = WhereCondition.createLessOrEquals(operand1, operand2);
      add(Connector.createAndConnector(cond));
   }
   
   public void andLessOrEquals(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         andLessOrEquals(operand1, operand2);
      }
   }
   
   public void andGreaterOrEquals(SQLString operand1, SQLString operand2)
   {
      WhereCondition cond = WhereCondition.createGreaterOrEquals(operand1, operand2);
      add(Connector.createAndConnector(cond));
   }
   
   public void andGreaterOrEquals(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         andGreaterOrEquals(operand1, operand2);
      }
   }
   
   public void andLike(SQLString operand1, Literal operand2)
   {
      WhereCondition cond = WhereCondition.createLike(operand1, operand2);
      add(Connector.createAndConnector(cond));
   }
   
   public void andLike(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         andLike(operand1, operand2);
      }
   }
   
   public void andIsNull(Table.Column operand)
   {
      WhereCondition cond = WhereCondition.createIsNull(operand);
      add(Connector.createAndConnector(cond));
   }
   
   public void andIsNull(Collection list)
   {
      Iterator iter = list.iterator();
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null || !(value instanceof Table.Column))
         {
            continue;
         }
         andIsNull((Table.Column) value);
      }
   }
   
   public void andIsNotNull(Table.Column operand)
   {
      WhereCondition cond = WhereCondition.createIsNotNull(operand);
      add(Connector.createAndConnector(cond));
   }
   
   public void andIsNotNull(Collection list)
   {
      Iterator iter = list.iterator();
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null || !(value instanceof Table.Column))
         {
            continue;
         }
         andIsNotNull((Table.Column) value);
      }
   }
   
   public Group andGroup()
   {
      Group group = new Group();
      add(Connector.createAndConnector(group));
      return group;
   }
   
   public void orEquals(SQLString operand1, SQLString operand2)
   {
      WhereCondition cond = WhereCondition.createEquals(operand1, operand2);
      add(Connector.createOrConnector(cond));
   }
   
   public void orEquals(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         orEquals(operand1, operand2);
      }
   }
   
   public void orNotEquals(SQLString operand1, SQLString operand2)
   {
      WhereCondition cond = WhereCondition.createNotEquals(operand1, operand2);
      add(Connector.createOrConnector(cond));
   }
   
   public void orNotEquals(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         orNotEquals(operand1, operand2);
      }
   }
   
   public void orLessThan(SQLString operand1, SQLString operand2)
   {
      WhereCondition cond = WhereCondition.createLessThan(operand1, operand2);
      add(Connector.createOrConnector(cond));
   }
   
   public void orLessThan(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         orLessThan(operand1, operand2);
      }
   }
   
   public void orGreaterThan(SQLString operand1, SQLString operand2)
   {
      WhereCondition cond = WhereCondition.createGreaterThan(operand1, operand2);
      add(Connector.createOrConnector(cond));
   }
   
   public void orGreaterThan(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         orGreaterThan(operand1, operand2);
      }
   }
   
   public void orLessOrEquals(SQLString operand1, SQLString operand2)
   {
      WhereCondition cond = WhereCondition.createLessOrEquals(operand1, operand2);
      add(Connector.createOrConnector(cond));
   }
   
   public void orLessOrEquals(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         orLessOrEquals(operand1, operand2);
      }
   }
   
   public void orGreaterOrEquals(SQLString operand1, SQLString operand2)
   {
      WhereCondition cond = WhereCondition.createGreaterOrEquals(operand1, operand2);
      add(Connector.createOrConnector(cond));
   }
   
   public void orGreaterOrEquals(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         orGreaterOrEquals(operand1, operand2);
      }
   }
   
   public void orLike(SQLString operand1, Literal operand2)
   {
      WhereCondition cond = WhereCondition.createLike(operand1, operand2);
      add(Connector.createOrConnector(cond));
   }
   
   public void orLike(SQLString operand1, Collection list, Literal template)
   {
      Iterator iter = list.iterator();
      Literal operand2 = null;
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null)
         {
            continue;
         }
         operand2 = template.clone(value.toString());
         orLike(operand1, operand2);
      }
   }
   
   public void orIsNull(Table.Column operand)
   {
      WhereCondition cond = WhereCondition.createIsNull(operand);
      add(Connector.createOrConnector(cond));
   }
   
   public void orIsNull(Collection list)
   {
      Iterator iter = list.iterator();
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null || !(value instanceof Table.Column))
         {
            continue;
         }
         orIsNull((Table.Column) value);
      }
   }
   
   public void orIsNotNull(Table.Column operand)
   {
      WhereCondition cond = WhereCondition.createIsNotNull(operand);
      add(Connector.createOrConnector(cond));
   }
   
   public void orIsNotNull(Collection list)
   {
      Iterator iter = list.iterator();
      Object value = null;
      while (iter.hasNext())
      {
         value = iter.next();
         if (value == null || !(value instanceof Table.Column))
         {
            continue;
         }
         orIsNotNull((Table.Column) value);
      }
   }
   
   public Group orGroup()
   {
      Group group = new Group();
      add(Connector.createOrConnector(group));
      return group;
   }
   
   private void add(Connector condition)
   {
      SQLString cond = condition;
      if (_list == null)
      {
         _list = new ArrayList();
         cond = condition.getConnectee();
      }
      _list.add(cond);
   }
   
   public StringBuffer addString(StringBuffer buffer)
   {
      Iterator iter = _list.iterator();
      while (iter.hasNext())
      {
         ((SQLString) iter.next()).addString(buffer);
         if (iter.hasNext())
         {
            buffer.append(" ");
         }
      }
      return buffer;
   }

}
