/*
 * Created on Feb 17, 2006
 *
 * Unpublished Work, Copyright, 2005, 2006 Northrop Grumman
 */
package gov.grants.common.sql;

import java.util.HashMap;

/**
 * @author david.wong2@ngc.com, Grants.gov Team 
 *
 * Represents a table within a SQL statement.
 */
public class Table
   implements SQLString
{
   private String _name = null;
   private String _alias = null;
   private HashMap _columns = null;

   public Table(String name)
   {
      _name = name.toUpperCase();
      _alias = _name.toLowerCase();
   }

   public final String getName()
   {
      return _name;
   }
   
   public final String getAlias()
   {
      return _alias;
   }
   
   public final Column column(String name)
   {
      if (_columns == null)
      {
         _columns = new HashMap();
      }
      Column col = (Table.Column) _columns.get(name);
      if (col == null)
      {
         col = new Column(name);
         _columns.put(name, col);
      }
      return col;
   }

   public StringBuffer addString(StringBuffer buffer)
   {
      return buffer.append(_name).append(" ").append(_alias);
   }
   
   public final class Column
      implements SQLString
   {
      private String _name = null;
      
      private Column(String name)
      {
         _name = name;
      }
      
      public final String getName()
      {
         return _name;
      }
      
      public final Table getTable()
      {
         return Table.this;
      }
      
      public StringBuffer addString(StringBuffer buffer)
      {
         return buffer.append(Table.this.getAlias()).append(".").append(_name);
      }
   }
}
